import {NativeModules} from 'react-native';
const DYReact = NativeModules.DYReact;

export const initDY = () => {
  DYReact.setSecret('569bb4b05f49228f315e133c', (state: string) => {
    console.log('returned with state: ' + state);
  });
};

export const trackEvent = () => {
  DYReact.trackEvent(
    'button clicked',
    {button: 'trackEvent'},
    (eventName: string) => {
      console.log('trackEvent called with: ' + eventName);
    },
  );
};

export const sendPageView = () => {
  DYReact.pageView('screen viewed', {name: 'home'}, (pageName: string) => {
    console.log('sendPageView called with: ' + pageName);
  });
};

export const consentOptIn = () => {
  DYReact.consentOptIn();
};

export const consentOptOut = () => {
  DYReact.consentOptOut();
};

export const setEvaluator = () => {
  DYReact.setEvaluator(
    'cartValue',
    [1000],
    false,
    (evaluatorID: string, params: [any], isPersistent: number) => {
      console.log(
        `sendPageView called with: ${evaluatorID},${params},${isPersistent}`,
      );
    },
  );
};

export const getSmartObjectData = () => {
  DYReact.getSmartObjectData(
    'objectName',
    (smartObjectID: string, result: any) => {
      console.log(
        `getSmartObjectData returned with: ${smartObjectID},${result}`,
      );
    },
  );
};

export const getSmartVariable = () => {
  DYReact.getSmartVariable('variableName', (result: any) => {
    console.log(`getSmartVariable returned with: ${result}`);
  });
};

export const identifyUser = () => {
  DYReact.identifyUser('userData', (error: any) => {
    if (error) {
      console.log(`identifyUser returned with: ${error}`);
    }
  });
};

export const setUseEuropeanServer = () => {
  DYReact.setUseEuropeanServer(false);
};

export const sendRecommendationRequest = () => {
  DYReact.sendRecommendationRequest(
    'widgetID',
    '{context}',
    (result: object[], widgetID: string) => {
      console.log(
        `sendRecommendationRequest for ${widgetID} returned with: ${result}`,
      );
    },
  );
};

export const trackRecomItemRealImpression = () => {
  DYReact.trackRecomItemRealImpression('widgetID', '[itemIDs]');
};

export const trackRecomItemClick = () => {
  DYReact.trackRecomItemClick('widgetID', 'itemID');
};
